% operators

% modification operators, modops
modop(assign,[att(AttL),AttOrDomain]):-
	att_or_domain_or_evalop_value(AttOrDomain,Val),
	setattval(AttL,Val).

% modop should always suceed
modop(Op,Vals):-
	(bheart(debug) -> write('modop fails: '), write(Op), write(':'), write(Vals), nl ; true).


% evaluative operators
evalop(add,[ArgL,ArgR],[Value]):-
	att_or_domain_or_evalop_value(ArgL,[ValL]),
	att_or_domain_or_evalop_value(ArgR,[ValR]),
	Value is ValL + ValR.
evalop(sub,[ArgL,ArgR],[Value]):-
	att_or_domain_or_evalop_value(ArgL,[ValL]),
	att_or_domain_or_evalop_value(ArgR,[ValR]),
	Value is ValL - ValR.
evalop(insert,[ListA,IdxA,ValA],Value):- % insert a value into list at given idx
	att_or_domain_or_evalop_value(ListA,List),
	att_or_domain_or_evalop_value(IdxA,[Idx]),
	att_or_domain_or_evalop_value(ValA,[Val]),
	length(List,Len),
	RLen is Len - Idx,
	length(L,Idx),
	length(R,RLen),
	append(L,R,List),
	append(L,[Val|R],Value).
evalop(insert,[ListA,IdxA,ValA],Value):- % insert a value into list at given idx
	att_or_domain_or_evalop_value(ListA,List),
	att_or_domain_or_evalop_value(IdxA,[Idx]),
	att_or_domain_or_evalop_value(ValA,[Val]),
	length(List,Len),
	Idx > Len,
	EmptyListLen is Idx - Len,
	fillempty(EmptyList,EmptyListLen),
	append(List,EmptyList,LE),
	append(LE,[Val],Value).

evalop(remove,[ListA,IdxA],Value):- % remove a value from list at given idx
	att_or_domain_or_evalop_value(ListA,List),
	att_or_domain_or_evalop_value(IdxA,[Idx]),
	length(List,Len),
	RLen is Len - Idx - 1,
	length(L,Idx),
	length(R,RLen),
	append(L,[_|R],List),
	append(L,R,Value).

% evalop(insert,_) helper
fillempty([[]],1).
fillempty([[]|T],N):-
	N > 1,
	NN is N -1,
	fillempty(T,NN).


% conditional operators, logops, logical operators
% I/O is not performed here, should be performed before checking conditions
logop(eq,[att(AttributeLeft), AttOrDomain]):-
	attval(AttributeLeft,Value),
	att_or_domain_value(AttOrDomain,Value).
logop(neq,A):-
	\+ logop(eq,A).

% in works for single valued attribs only
logop(in,[att(AttributeLeft), AttOrDomain]):-
     attval(AttributeLeft,[Value]),
     att_or_domain_value(AttOrDomain,Set),
     member(Value,Set).
	
logop(notin,A):-
	\+ logop(in,A).
	
% more to declare FIXME
