% The i/o framework provides attread/1 predicate which spawns
% appropriate triggers if necessary for reading in attribute values,
% similarily attwrite/1 spawns appropriate triggers for writting
% attribute values.
% usage: attread(attribute_name)
% reads attribute value using appropriate triggers
% ie.
% ?- attread(in).
% spawns apropriate trigger for 'in' attribute


% Separate predicates for reading in attribute values (for ro and rw)
% and for writting attribute values out (for ro and wo) are a must.
% It cannot be a single predicate because of rw attributes

%ro,rw attribute
attread(Attribute):- 
	is_read_class(Attribute),
	io(Attribute,ro_trigger,PredicateName),
	Predicate =.. [PredicateName, Val],
	Predicate,
	setattval(Attribute,Val).
attread(_).

%wo,rw attribute
attwrite(Attribute):- 
	is_write_class(Attribute),
	io(Attribute,wo_trigger,PredicateName),
	attval(Attribute,Value),
	Predicate =.. [PredicateName, Value, Return],
	Predicate,
	setattval(Attribute,Return).
attwrite(_).
