:-[runtime].
:-[prolog-runtime].


%attml---------------
%the following facts are for testing purposes only
% an attribute is defined as:
%att(id,name,abbrev,typeId,multi,io)

att(att_01,in,in,tpe_01,single,ro).
att(att_02,out,out,tpe_01,single,wo).
att(att_03,inout,io,tpe_01,multiple,rw).

% attribute types:
%type(typeId,name,baseType,length,scale,domain,rangesOrValues)

type(tpe_01,tempType,numeric,3,0,ordered,[range(-5,6),7,8,range(9,30)]).

%attml ends----------

%attribute values will be stored as:
%attval(attId,listOfValues)


% below there are trigger definitions
%io(attId,triggerType,predName)

io(att_01,ro_trigger,getfrom).
io(att_02,wo_trigger,setto).
io(att_03,ro_trigger,getfromlist).
io(att_03,wo_trigger,settolist).


% trigger predicates are given below:

getfrom([-5]).

setto(X,[1]):-write('output:'), write(X),nl.

getfromlist([6,7,8]).

settolist(X,[1,2]):-write('list output:'), write(X),nl.


% test cases
%ro class attribute
test(ro):-
	write('reading\n'), attread(att_01), write('reading successful...\n'),attdisp(att_01).
%wo class attribute
test(wo):-
	write('writing\n'), setattval(att_02,[3]), attdisp(att_02), attwrite(att_02), write('writing successfull...\n'), attdisp(att_02).
%rw class attribute
test(rw):-
	write('reading\n'), attread(att_03), write('reading successful...\n'),attdisp(att_03),
	write('writing\n'), attwrite(att_03), write('writing successful...\n'),attdisp(att_03).

%test all cases
testall:- clause(test(X),_), write('--->'), write(X), nl, test(X), fail.
testall:-write('end of line...\n').

:-testall.
